package ch2.sec1;

public class Selection {
    public static void sort(Comparable[] a) {
        for (int i = 0; i < a.length; i++) {
            Comparable min = a[i];
            int index = i;
            for (int j = i + 1; j < a.length; j++) {
                if (less(a[j], min)) {
                    min = a[j];
                    index = j;
                }
            }
            exch(a, i, index);
        }
    }

    private static boolean less(Comparable v, Comparable w) {
        return v.compareTo(w) < 0;
    }

    private static void exch(Comparable[] a, int i, int j) {
        Comparable t = a[i];
        a[i] = a[j];
        a[j] = t;
    }

    public static void main(String[] args) {
        Integer[] num = new Integer[] {2,1,4,2,5};
        Selection.sort(num);
        for (int n:num) {
            System.out.println(n);
        }
    }
}
